const char serpent_lua[] =
"local n, v = \"serpent\", \"0.302\" -- (C) 2012-18 Paul Kulchenko; MIT License\n"
"local c, d = \"Paul Kulchenko\", \"Lua serializer and pretty printer\"\n"
"local snum = {[tostring(1/0)]='1/0 --[[math.huge]]',[tostring(-1/0)]='-1/0 --[[-math.huge]]',[tostring(0/0)]='0/0'}\n"
"local badtype = {thread = true, userdata = true, cdata = true}\n"
"local getmetatable = debug and debug.getmetatable or getmetatable\n"
"local pairs = function(t) return next, t end -- avoid using __pairs in Lua 5.2+\n"
"local keyword, globals, G = {}, {}, (_G or _ENV)\n"
"for _,k in ipairs({'and', 'break', 'do', 'else', 'elseif', 'end', 'false',\n"
"  'for', 'function', 'goto', 'if', 'in', 'local', 'nil', 'not', 'or', 'repeat',\n"
"  'return', 'then', 'true', 'until', 'while'}) do keyword[k] = true end\n"
"for k,v in pairs(G) do globals[v] = k end -- build func to name mapping\n"
"for _,g in ipairs({'coroutine', 'debug', 'io', 'math', 'string', 'table', 'os'}) do\n"
"  for k,v in pairs(type(G[g]) == 'table' and G[g] or {}) do globals[v] = g..'.'..k end end\n"
"\n"
"local function s(t, opts)\n"
"  local name, indent, fatal, maxnum = opts.name, opts.indent, opts.fatal, opts.maxnum\n"
"  local sparse, custom, huge = opts.sparse, opts.custom, not opts.nohuge\n"
"  local space, maxl = (opts.compact and '' or ' '), (opts.maxlevel or math.huge)\n"
"  local maxlen, metatostring = tonumber(opts.maxlength), opts.metatostring\n"
"  local iname, comm = '_'..(name or ''), opts.comment and (tonumber(opts.comment) or math.huge)\n"
"  local numformat = opts.numformat or \"%.17g\"\n"
"  local seen, sref, syms, symn = {}, {'local '..iname..'={}'}, {}, 0\n"
"  local function gensym(val) return '_'..(tostring(tostring(val)):gsub(\"[^%w]\",\"\"):gsub(\"(%d%w+)\",\n"
"    -- tostring(val) is needed because __tostring may return a non-string value\n"
"    function(s) if not syms[s] then symn = symn+1; syms[s] = symn end return tostring(syms[s]) end)) end\n"
"  local function safestr(s) return type(s) == \"number\" and tostring(huge and snum[tostring(s)] or numformat:format(s))\n"
"    or type(s) ~= \"string\" and tostring(s) -- escape NEWLINE/010 and EOF/026\n"
"    or (\"%q\"):format(s):gsub(\"\\010\",\"n\"):gsub(\"\\026\",\"\\\\026\") end\n"
"  local function comment(s,l) return comm and (l or 0) < comm and ' --[['..select(2, pcall(tostring, s))..']]' or '' end\n"
"  local function globerr(s,l) return globals[s] and globals[s]..comment(s,l) or not fatal\n"
"    and safestr(select(2, pcall(tostring, s))) or error(\"Can't serialize \"..tostring(s)) end\n"
"  local function safename(path, name) -- generates foo.bar, foo[3], or foo['b a r']\n"
"    local n = name == nil and '' or name\n"
"    local plain = type(n) == \"string\" and n:match(\"^[%l%u_][%w_]*$\") and not keyword[n]\n"
"    local safe = plain and n or '['..safestr(n)..']'\n"
"    return (path or '')..(plain and path and '.' or '')..safe, safe end\n"
"  local alphanumsort = type(opts.sortkeys) == 'function' and opts.sortkeys or function(k, o, n) -- k=keys, o=originaltable, n=padding\n"
"    local maxn, to = tonumber(n) or 12, {number = 'a', string = 'b'}\n"
"    local function padnum(d) return (\"%0\"..tostring(maxn)..\"d\"):format(tonumber(d)) end\n"
"    table.sort(k, function(a,b)\n"
"      -- sort numeric keys first: k[key] is not nil for numerical keys\n"
"      return (k[a] ~= nil and 0 or to[type(a)] or 'z')..(tostring(a):gsub(\"%d+\",padnum))\n"
"           < (k[b] ~= nil and 0 or to[type(b)] or 'z')..(tostring(b):gsub(\"%d+\",padnum)) end) end\n"
"  local function val2str(t, name, indent, insref, path, plainindex, level)\n"
"    local ttype, level, mt = type(t), (level or 0), getmetatable(t)\n"
"    local spath, sname = safename(path, name)\n"
"    local tag = plainindex and\n"
"      ((type(name) == \"number\") and '' or name..space..'='..space) or\n"
"      (name ~= nil and sname..space..'='..space or '')\n"
"    if seen[t] then -- already seen this element\n"
"      sref[#sref+1] = spath..space..'='..space..seen[t]\n"
"      return tag..'nil'..comment('ref', level) end\n"
"    -- protect from those cases where __tostring may fail\n"
"    if type(mt) == 'table' and metatostring ~= false then\n"
"      local to, tr = pcall(function() return mt.__tostring(t) end)\n"
"      local so, sr = pcall(function() return mt.__serialize(t) end)\n"
"      if (to or so) then -- knows how to serialize itself\n"
"        seen[t] = insref or spath\n"
"        t = so and sr or tr\n"
"        ttype = type(t)\n"
"      end -- new value falls through to be serialized\n"
"    end\n"
"    if ttype == \"table\" then\n"
"      if level >= maxl then return tag..'{}'..comment('maxlvl', level) end\n"
"      seen[t] = insref or spath\n"
"      if next(t) == nil then return tag..'{}'..comment(t, level) end -- table empty\n"
"      if maxlen and maxlen < 0 then return tag..'{}'..comment('maxlen', level) end\n"
"      local maxn, o, out = math.min(#t, maxnum or #t), {}, {}\n"
"      for key = 1, maxn do o[key] = key end\n"
"      if not maxnum or #o < maxnum then\n"
"        local n = #o -- n = n + 1; o[n] is much faster than o[#o+1] on large tables\n"
"        for key in pairs(t) do if o[key] ~= key then n = n + 1; o[n] = key end end end\n"
"      if maxnum and #o > maxnum then o[maxnum+1] = nil end\n"
"      if opts.sortkeys and #o > maxn then alphanumsort(o, t, opts.sortkeys) end\n"
"      local sparse = sparse and #o > maxn -- disable sparsness if only numeric keys (shorter output)\n"
"      for n, key in ipairs(o) do\n"
"        local value, ktype, plainindex = t[key], type(key), n <= maxn and not sparse\n"
"        if opts.valignore and opts.valignore[value] -- skip ignored values; do nothing\n"
"        or opts.keyallow and not opts.keyallow[key]\n"
"        or opts.keyignore and opts.keyignore[key]\n"
"        or opts.valtypeignore and opts.valtypeignore[type(value)] -- skipping ignored value types\n"
"        or sparse and value == nil then -- skipping nils; do nothing\n"
"        elseif ktype == 'table' or ktype == 'function' or badtype[ktype] then\n"
"          if not seen[key] and not globals[key] then\n"
"            sref[#sref+1] = 'placeholder'\n"
"            local sname = safename(iname, gensym(key)) -- iname is table for local variables\n"
"            sref[#sref] = val2str(key,sname,indent,sname,iname,true) end\n"
"          sref[#sref+1] = 'placeholder'\n"
"          local path = seen[t]..'['..tostring(seen[key] or globals[key] or gensym(key))..']'\n"
"          sref[#sref] = path..space..'='..space..tostring(seen[value] or val2str(value,nil,indent,path))\n"
"        else\n"
"          out[#out+1] = val2str(value,key,indent,nil,seen[t],plainindex,level+1)\n"
"          if maxlen then\n"
"            maxlen = maxlen - #out[#out]\n"
"            if maxlen < 0 then break end\n"
"          end\n"
"        end\n"
"      end\n"
"      local prefix = string.rep(indent or '', level)\n"
"      local head = indent and '{\\n'..prefix..indent or '{'\n"
"      local body = table.concat(out, ','..(indent and '\\n'..prefix..indent or space))\n"
"      local tail = indent and \"\\n\"..prefix..'}' or '}'\n"
"      return (custom and custom(tag,head,body,tail,level) or tag..head..body..tail)..comment(t, level)\n"
"    elseif badtype[ttype] then\n"
"      seen[t] = insref or spath\n"
"      return tag..globerr(t, level)\n"
"    elseif ttype == 'function' then\n"
"      seen[t] = insref or spath\n"
"      if opts.nocode then return tag..\"function() --[[..skipped..]] end\"..comment(t, level) end\n"
"      local ok, res = pcall(string.dump, t)\n"
"      local func = ok and \"((loadstring or load)(\"..safestr(res)..\",'@serialized'))\"..comment(t, level)\n"
"      return tag..(func or globerr(t, level))\n"
"    else return tag..safestr(t) end -- handle all other types\n"
"  end\n"
"  local sepr = indent and \"\\n\" or \";\"..space\n"
"  local body = val2str(t, name, indent) -- this call also populates sref\n"
"  local tail = #sref>1 and table.concat(sref, sepr)..sepr or ''\n"
"  local warn = opts.comment and #sref>1 and space..\"--[[incomplete output with shared/self-references skipped]]\" or ''\n"
"  return not name and body..warn or \"do local \"..body..sepr..tail..\"return \"..name..sepr..\"end\"\n"
"end\n"
"\n"
"local function deserialize(data, opts)\n"
"  local env = (opts and opts.safe == false) and G\n"
"    or setmetatable({}, {\n"
"        __index = function(t,k) return t end,\n"
"        __call = function(t,...) error(\"cannot call functions\") end\n"
"      })\n"
"  local f, res = (loadstring or load)('return '..data, nil, nil, env)\n"
"  if not f then f, res = (loadstring or load)(data, nil, nil, env) end\n"
"  if not f then return f, res end\n"
"  if setfenv then setfenv(f, env) end\n"
"  return pcall(f)\n"
"end\n"
"\n"
"local function merge(a, b) if b then for k,v in pairs(b) do a[k] = v end end; return a; end\n"
"return { _NAME = n, _COPYRIGHT = c, _DESCRIPTION = d, _VERSION = v, serialize = s,\n"
"  load = deserialize,\n"
"  dump = function(a, opts) return s(a, merge({name = '_', compact = true, sparse = true}, opts)) end,\n"
"  line = function(a, opts) return s(a, merge({sortkeys = true, comment = true}, opts)) end,\n"
"  block = function(a, opts) return s(a, merge({indent = '  ', sortkeys = true, comment = true}, opts)) end }\n"
""
;
